import { expect, tap } from '@push.rocks/tapbundle';
import { Qenv } from '@push.rocks/qenv';
const testQenv = new Qenv('./', './.nogit/');

delete process.env.CLI_CALL;

import * as cloudly from '../ts/index';

process.env.TESTING_CLOUDLY = 'true';

let testCloudly: cloudly.Cloudly;

tap.test('first test', async () => {
  const cloudlyConfig: cloudly.ICloudlyConfig = {
    cfToken: testQenv.getEnvVarOnDemand('CF_TOKEN'),
    environment: 'integration',
    letsEncryptEmail: testQenv.getEnvVarOnDemand('LETSENCRYPT_EMAIL'),
    publicUrl: testQenv.getEnvVarOnDemand('SERVEZONE_URL'),
    publicPort: testQenv.getEnvVarOnDemand('SERVEZONE_PORT'),
    mongoDescriptor: {
      mongoDbName: testQenv.getEnvVarOnDemand('MONGODB_DATABASE'),
      mongoDbPass: testQenv.getEnvVarOnDemand('MONGODB_PASSWORD'),
      mongoDbUrl: testQenv.getEnvVarOnDemand('MONGODB_URL')
    },
    digitalOceanToken: testQenv.getEnvVarOnDemand('DIGITALOCEAN_TOKEN')
  };
  testCloudly = new cloudly.Cloudly(cloudlyConfig);
  expect(testCloudly).to.be.instanceof(cloudly.Cloudly);
});

tap.test('should init servezone', async () => {
  await testCloudly.start();
});

tap.test('should end the service', async () => {
  await testCloudly.stop();
});

tap.start();
