export interface ISecretBundle {
  id: string;
  data: {
    name: string;
    description: string;

    /**
     * determines if the secret is a service or an external secret
     * if external secret additional checks are put in place to protect the secret
     */
    type: 'service' | 'npmci' | 'gitzone' | 'external';

    /**
     * You can add specific secret groups using this
     */
    includedSecretGroupIds: string[];

    /**
     * You can add specific tags using this
     */
    includedTags: {
      key: string;
      value?: string;
    }[];

    /**
     * add images
     */
    includedImages: {
      imageId: string;
      permissions: ('read' | 'write')[];
    }[]; 

    /**
     * authrozations select a specific environment of a config bundle
     */
    authorizations: Array<{
      secretAccessKey: string;
      environment: string;
    }>;
  };
}
