import type { IServiceRessources } from './docker.js';

export interface IService {
  id: string;
  data: {
    name: string;
    imageId: string;
    imageVersion: string;
    environment: { [key: string]: string };
    secretBundleId: string;
    scaleFactor: number;
    balancingStrategy: 'round-robin' | 'least-connections';
    ports: {
      web: number;
      custom?: { [domain: string]: string };
    };
    resources?: IServiceRessources;
    domains: {
      name: string;
      port?: number;
      protocol?: 'http' | 'https' | 'ssh';
    }[];
    deploymentIds: string[];
    deploymentDirectiveIds: string[];
  };
}
