import * as plugins from '../plugins.js';

export type TTemplates = 'default' | 'linkaction' | 'notification';

export interface IRequest_SendEmail extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IRequest_SendEmail
> {
  method: 'sendEmail';
  request: {
    title: string;
    from: string;
    to: string;
    body: string;
    attachments?: Array<{
      name: string;
      binaryAttachmentString: string;
    }>
  };
  response: {
    /**
     * the response id allows for handling of responses to that email
     */
    responseId: string;
  };
}

export interface IRequestRegisterRecipient extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IRequestRegisterRecipient
> {
  method: 'registerRecepient';
  request: {
    emailAddress: string;
  };
  response: {
    status: 'ok' | 'not ok';
  };
}
